	subroutine energy

c	advances the internal energy equation for bin <= highbin

	include'comblock'

	integer i,add,newbin
	real unew,dudt,sum,tfactor

	sum=0.0

c       get internal energy at end of current timestep

	do i=1,tcount
	 add=tlist(i)

c	get simplest estimate for dudt

         dudt=-(axgas(add)*vx(add)+aygas(add)*vy(add)+
     1    azgas(add)*vz(add))

         if((u(add)+dudt*delt(partbin(add))).gt.umin) then

c	store and rebuild bin

	  newbin=partbin(add)
	  headbin(newbin)=headbin(newbin)+1
	  bin(headbin(newbin),newbin)=add

	  ec21=ec21+1
          u(add)=(u(add)+dudt*delt(partbin(add)))
          cs(add)=sqrt(cscon*u(add))
	  sum=sum+dudt*delt(partbin(add))

         else if(partbin(add).gt.1) then

c	try a smaller timestep

	  newbin=partbin(add)
10	  newbin=newbin-1
	  tfactor=delt12(newbin)-delt12(partbin(add))
          dudt=-(axgas(add)*(vx(add)+ax(add)*tfactor)+
     1	   aygas(add)*(vy(add)+ay(add)*tfactor)+
     1     azgas(add)*(vz(add)+az(add)*tfactor))
	  unew=u(add)+dudt*delt(newbin)

          if(unew.gt.umin) then

c	store and rebuild bin

	   partbin(add)=newbin
	   headbin(newbin)=headbin(newbin)+1
	   bin(headbin(newbin),newbin)=add

	   ec21=ec21+1
           u(add)=unew
           cs(add)=sqrt(cscon*unew)
	   vx(add)=vx(add)+ax(add)*tfactor
	   vy(add)=vy(add)+ay(add)*tfactor
	   vz(add)=vz(add)+az(add)*tfactor
	   sum=sum+dudt*delt(newbin)
	  
	   else if(newbin.gt.1) then

c	try the next smaller timestep

	    go to 10

           else

c	simple method doesn't work, try another method.
c	The timestep remains at the original one but is changed
c	as needed  

	    call euler(add,sum)
	   end if  ! unew>=umin

	  else
	
c	simple method doesn't work, try another method.
c	The timestep remains at the original one but is changed
c	as needed  

	   call euler(add,sum)

	 end if
	end do ! i=1,tcount

	enersum=enersum+sum
	return
	end


	subroutine euler(add,sum)

c	tries simple euler algorithm to integrate the internal energy

	include'comblock'

	integer i,add,tadd,newbin
	real fac,tvrdot,dudt,sum,tfactor

	dudt=0.0

c	now get du/dut

	do i=2,headlist(add)
	 if(partbin(list(i,add)).le.highbin) then
	 tadd=list(i,add)
         tvrdot=(x(add)-x(tadd))*(vxend(add)-vxend(tadd))+
     1    (y(add)-y(tadd))*(vyend(add)-vyend(tadd))+
     1    (z(add)-z(tadd))*(vzend(add)-vzend(tadd))
         if(tvrdot.lt.0.0) then
          fac=tvrdot*rsqeta(kerindex(i,add))/(cs(add)+cs(tadd))
          dudt=dudt+(1.0+fac*(alpha+beta*fac))*tvrdot*
     1      grdkernel(kerindex(i,add))
         else
            dudt=dudt+tvrdot*grdkernel(kerindex(i,add))
         end if  ! tvrdot<0
	 end if
	end do  ! i

	dudt=pressrho(add)*dudt

c	check for u(add)>umin

       if(u(add)+dudt*delt(partbin(add)).gt.umin) then

c	store and rebuild bin

         ec22=ec22+1
	 newbin=partbin(add)
         u(add)=u(add)+dudt*delt(newbin)
         cs(add)=sqrt(cscon*u(add))
         newbin=partbin(add)
         headbin(newbin)=headbin(newbin)+1
         bin(headbin(newbin),newbin)=add
         sum=sum+dudt*delt(newbin)
 
        else if(partbin(add).gt.1) then

c	try a smller timestep

         newbin=partbin(add)
20       newbin=newbin-1
         if(u(add)+dudt*delt(newbin).gt.umin) then

          ec22=ec22+1
          u(add)=u(add)+dudt*delt(newbin)
          cs(add)=sqrt(cscon*u(add))
	  tfactor=delt12(newbin)-delt12(partbin(add))
          partbin(add)=newbin
          headbin(newbin)=headbin(newbin)+1
          bin(headbin(newbin),newbin)=add
          sum=sum+dudt*delt(newbin)
          vx(add)=vx(add)+ax(add)*tfactor
          vy(add)=vy(add)+ay(add)*tfactor
          vz(add)=vz(add)+az(add)*tfactor

         else if(newbin.gt.1) then
          
          go to 20

         else  ! must fudge, put particle in bin 1

          sum=sum+(ufudge-u(add))
          u(add)=ufudge
	  cs(add)=csfudge
	  tfactor=deltmin12-delt12(partbin(add))
          badness2=badness2+1
          partbin(add)=1
          headbin(1)=headbin(1)+1
          bin(headbin(1),1)=add
          vx(add)=vx(add)+ax(add)*tfactor
          vy(add)=vy(add)+ay(add)*tfactor
          vz(add)=vz(add)+az(add)*tfactor

         end if

        else  ! must fudge, put particle in bin 1

         sum=sum+(ufudge-u(add))
         u(add)=ufudge
         cs(add)=csfudge
	 tfactor=deltmin12-delt12(partbin(add))
         badness2=badness2+1
         partbin(add)=1
         headbin(1)=headbin(1)+1
         bin(headbin(1),1)=add
         vx(add)=vx(add)+ax(add)*tfactor
         vy(add)=vy(add)+ay(add)*tfactor
         vz(add)=vz(add)+az(add)*tfactor

        end if

        return
        end
