C Programmer: Chris Burke
C Date: June 23, 1997
C Purpose: From particle temperatures get u,b,v sum from table
C add all these up to get total sums then find magnitude

      Subroutine mags

C Declare variables
      implicit none
      include 'comblock'
      include 'tubecom'
      integer kmin,m,msum,i,j,k,tsum
      double precision uxtot,btot,vtot,uxextra,bextra,vextra,bxtot
      double precision tval,uxmag,bmag,vmag,rtot,etot,rextra,bxextra
      double precision eextra,rmag,emag,bxmag
      real tempt

C Begin subroutine
      msum=0
      tsum=0
      uxtot=0.0d0
      bxtot=0.0d0
      btot=0.0d0
      vtot=0.0d0
      rtot=0.0d0
      etot=0.0d0
C Find the magnitude from a single tube
      Do i=1,ntt
         k=headtub(i)
         If (k.eq.0) goto 3
         IF (k.GE.numpart) tsum=tsum+1
         m=MIN(k,numpart)
         kmin=(k-m+1)
         Do j=k,kmin,-1
            tempt=temperature(tublist(j,i))
            msum=msum+1
C make sure temp doesn't explode when taking log
            If (tempt.lt.1.0) goto 6
C Squishy happens here
            tval=DBLE((LOG10(tempt)**sfs)+sft)
C Make sure temperature is withing bounds of table
            if (tval.lt.LOG10(5.0d2)) goto 6
            if (tval.gt.LOG10(5.0d5)) print *,
     &          'temp greater than table! ',10**tval
C Interpolate table to get magnitude
            call splint(temps,uxsums,uxsums2,numtemps,tval,uxextra)
            call splint(temps,bxsums,bxsums2,numtemps,tval,bxextra)
            call splint(temps,bsums,bsums2,numtemps,tval,bextra)
            call splint(temps,vsums,vsums2,numtemps,tval,vextra)
            call splint(temps,rsums,rsums2,numtemps,tval,rextra)
            call splint(temps,esums,esums2,numtemps,tval,eextra)
C Reduce magnitude using limb darkening
            uxextra=uxextra*zcomp(i)
            bxextra=bxextra*zcomp(i)
            bextra=bextra*zcomp(i)
            vextra=vextra*zcomp(i)
            rextra=rextra*zcomp(i)
            eextra=eextra*zcomp(i)

C Add to total
            uxtot=uxtot+uxextra
            bxtot=bxtot+bxextra
            btot=btot+bextra
            vtot=vtot+vextra
            rtot=rtot+rextra
            etot=etot+eextra
 6          continue
C finished with single particle
      End do
 3    continue
C Finished with single tube
      End do
C Find overall magnitude
      uxmag=(-2.5)*DLOG10(uxtot)
      bxmag=(-2.5)*DLOG10(bxtot)
      bmag=(-2.5)*DLOG10(btot)
      vmag=(-2.5)*DLOG10(vtot)
      rmag=(-2.5)*DLOG10(rtot)
      emag=(-2.5)*DLOG10(etot)

      valux(anglei)=uxmag
      valbx(anglei)=bxmag
      valb(anglei)=bmag
      valv(anglei)=vmag
      valr(anglei)=rmag
      vali(anglei)=emag
      partcnt(anglei)=msum
      tubcnt(anglei)=tsum
c      print 20, uxmag,bxmag,bmag,vmag,rmag,emag
c 20   format(1x,6(f9.5,1x))

C This will tell you how many particles were used in getting the total mag.
c      print *,msum


      Return
      End

