C     Programmer:Chris Burke
C     Date: June 16, 1997
C     Purpose: Take smoothed values from surf and find a tubes normal
C     based on neighboring tubes.  WARNING** This finds subroutine
C     finds out which quadrant the tube is in and gets neighboring
C     tubes such that the angle between the two surface vectors opens
C     towards the origins.  That is what the rs and ts variables are for.

      Subroutine norms

C Declare variables
      implicit none
      include 'comblock'
      include 'tubecom'
      real tubept(3),right(3),top(3),vect1(3),vect2(3),norm(3)
      real modn,rs,ts,limb1,limb2,rtubmax
      integer xi,yi,halftubmax,i

C Begin subroutine
      halftubmax=tubmax/2
      rtubmax=REAL(tubmax)
      limb1=(3.0/5.0)
      limb2=(2.0/3.0)
      xi=1
      yi=1      
      Do i=1,ntt
      zcomp(i)=0.0
C Get three vectors their tails are at the origin
C The head of tubept is the tube's x,y,z.  right vector
C is the x,y,z for the tube to the right.  top vector
C is the x,y,z for the tube up one y value.
         if (xi.gt.tubmax) Then
            xi=1
            yi=yi+1
         end if
         xi=xi+1
	 if(headtub(i).eq.0) go to 444
         tubept(1)=REAL(xi-1)
         tubept(2)=REAL(yi)
         tubept(3)=surf(i)
         rs=1.0
         ts=1.0
         if (xi.GT.halftubmax) rs=-1.0
         if (yi.GT.halftubmax) ts=-1.0
         right(1)=tubept(1)+rs
         right(2)=tubept(2)
         right(3)=surf(i+INT(rs))
         top(1)=tubept(1)
         top(2)=tubept(2)+ts
         top(3)=surf(i+NINT(rtubmax*ts))
         If (right(1).GT.rtubmax.OR.top(2).GT.rtubmax.OR.right(1).LT.1.0
     &     .OR.top(2).LT.1.0) goto 444
C Define two vectors to define the plane of the surface at tube
         vect1(1)=(right(1)-tubept(1))*tubwid
         vect1(2)=(right(2)-tubept(2))*tubwid
         vect1(3)=right(3)-tubept(3)
         vect2(1)=(top(1)-tubept(1))*tubwid
         vect2(2)=(top(2)-tubept(2))*tubwid
         vect2(3)=top(3)-tubept(3)
C Take cross product vect1 x vect2
         norm(1)=vect1(2)*vect2(3)-vect1(3)*vect2(2)
         norm(2)=vect1(3)*vect2(1)-vect1(1)*vect2(3)
         norm(3)=vect1(1)*vect2(2)-vect1(2)*vect2(1)
C Normalize
         modn=SQRT(norm(1)**2+norm(2)**2+norm(3)**2)
	 if(modn.eq.0.0) then
          norm(3)=0.0
	 else
	  norm(3)=norm(3)/modn
	 end if
         if (rs*ts.LT.0.0) norm(3)=-norm(3)

         zcomp(i)=norm(3)


C Get limb darkening ratio

c         zcomp(i)=limb1*(norm(3)+limb2)
 444     continue
      End do


      Return
      End








