C     Programmer:Chris Burke
C     Date: June 16, 1997
C     Purpose: Take smoothed values from surf and find a tubes normal
C     based on neighboring tubes.  WARNING** This finds subroutine
C     finds out which quadrant the tube is in and gets neighboring
C     tubes such that the angle between the two surface vectors opens
C     towards the origins.  That is what the rs and ts variables are for.

      Subroutine norms

C Declare variables
      implicit none
      include 'comblock'
      include 'tubecom'
      real tubept(3),right(3),top(3),vect1(3),vect2(3),norm(3)
      real modn,rs,ts,limb1,limb2,rtubmax
      integer xi,yi,halftubmax,i,k

C Begin subroutine
      halftubmax=tubmax/2
      rtubmax=REAL(tubmax)
      limb1=(3.0/5.0)
      limb2=(2.0/3.0)
      xi=1
      yi=1      
      Do i=1,ntt
C Get three vectors their tails are at the origin
C The head of tubept is the tube's x,y,z.  right vector
C is the x,y,z for the tube to the right.  top vector
C is the x,y,z for the tube up one y value.
         if (xi.gt.tubmax) Then
            xi=1
            yi=yi+1
         end if
         rs=1.0
         ts=1.0
         tubept(1)=REAL(xi)
         xi=xi+1
         tubept(2)=REAL(yi)
         tubept(3)=surf(i)
         k=headtub(i)
         if (k.eq.0) then
            norm(1)=0.0
            norm(2)=0.0
            norm(3)=0.0
            goto 444
         end if
         if (xi.GT.halftubmax) rs=-1.0
         if (yi.GT.halftubmax) ts=-1.0
         right(1)=tubept(1)+rs
         right(2)=tubept(2)
         right(3)=surf(i+INT(rs))
         top(1)=tubept(1)
         top(2)=tubept(2)+ts
         top(3)=surf(i+NINT(rtubmax*ts))
         If (right(1).GT.rtubmax.OR.top(2).GT.rtubmax.OR.right(1).LT.1.0
     &     .OR.top(2).LT.1.0) Then
            norm(1)=0.0
            norm(2)=0.0
            norm(3)=0.0
            goto 444
         End if
C Define two vectors to define the plane of the surface at tube
         vect1(1)=(right(1)-tubept(1))*tubwid
         vect1(2)=(right(2)-tubept(2))*tubwid
         vect1(3)=right(3)-tubept(3)
         vect2(1)=(top(1)-tubept(1))*tubwid
         vect2(2)=(top(2)-tubept(2))*tubwid
         vect2(3)=top(3)-tubept(3)
C Take cross product vect1 x vect2
         norm(1)=vect1(2)*vect2(3)-vect1(3)*vect2(2)
         norm(2)=vect1(3)*vect2(1)-vect1(1)*vect2(3)
         norm(3)=vect1(1)*vect2(2)-vect1(2)*vect2(1)
C Normalize
         modn=SQRT(norm(1)**2+norm(2)**2+norm(3)**2)
         norm(1)=norm(1)/modn
         norm(2)=norm(2)/modn
         norm(3)=norm(3)/modn
         if (rs*ts.LT.0.0) then
            norm(1)=-norm(1)
            norm(2)=-norm(2)
            norm(3)=-norm(3)
         end if
 444     continue
C Get limb darkening ratio
         zcomp(i)=limb1*(norm(3)+limb2)
C Use this block to print out vectors for display in dx
c         if (k.ne.0) then
c         print 60,(tubept(1)*tubwid),(tubept(2)*tubwid),tubept(3),
c     &           norm(1),norm(2),norm(3)
c 60      format(1x,6(f10.7,1x))
c         end if
      End do


      Return
      End








