
	subroutine outerlobe

c	determines the location of the outer Lagrange point L3
c	that is, the point opposite to m2 that has the same potential
c	as l1

	include'comblock'

	integer i,flag
	real equ,xt,xtxt,xtxtp,del,r1,r2

c	define the function which yields L3

	equ(xt)=phirl+(mu2/(xt+mu1))+(mu1/abs(xt-mu2))+
     1	.5*(mu2*(xt+mu1)**2+mu1*(xt-mu2)**2)

c	determine potential at xt=rl

	r1=rl+mu1
	r2=mu2-rl
	phirl=-.5*(mu2*r1*r1+mu1*r2*r2)-mu2/r1-mu1/r2

c	solve potential equation iteratively using 2*mu2-rl as initial
c	guess. This just starts xt at 2*mu2-rl, decreasing xt until an
c	adequately close zero is obtained.
c	initial guess for xt is as above, xtxtp=previous value for xt,del is
c	arbitrarily set at 0.1*(mu2-rl), i is counter for number of times
c	del is reduced by a factor of 10. flag is indicator if done

	xtxt=2.*mu2-rl
	xtxtp=xtxt
	del=.1*(mu2-rl)
	i=1
	flag=0
	
	do while (flag.eq.0)

c	first see if equ 0, if so decrease xt by del xt

	if(equ(xtxt).lt.0.0) then
		xtxtp=xtxt
		xtxt=xtxt-del

c	if equ>0, then go back to previous value of xtxt and decrease
c	del by factor of 10 and start again. The 5 means that the result
c	L1 is accurate out to about the 5 th decimal place since
c	del(initial) is about .1

	else if (equ(xtxt).gt.0.0.and.i.le.5) then
		del=0.1*del
		i=i+1
		xtxt=xtxtp-del

c	all done

	else
		flag=1
		rlo=xtxt
	end if

	end do

	print*,'rlo=',rlo,'  rlo-mu2=',rlo-mu2

	return
	end
	
