	subroutine setsys


	integer choice,answer
	real r2temp,temp,q

	include'comblock'

c 	gets all the system parameters for the entire simulation

	write (*,10)
10	format('Enter the total number of orbits:    ',$)
	read*,numorbmax

	write(*,11)
11	format('Enter m1 (solar masses): ',$)
	read*,m1

	write(*,12)
12	format('Enter m2 (solar masses): ',$)
	read*,m2

c 	calculate reduced masses for the stars

	mu1=m2/(m1+m2)
	mu2=m1/(m1+m2)

c 	calculate the inner lagrange point l1 for the masses m1 and m2

	call lagrange

	call outerlobe

	call equipot

c	set size of m2

	q=m2/m1
	temp=(0.49*(q**0.66667))/(0.6*(q**0.66667)+log(1+(q**.33334)))
	lm2=temp
	lm2sq=lm2*lm2

c	print out lm2

	if (debug) print*,'in setsys lm2 from mr relation=', lm2

c	decide how to set orbital separation and period

5	write(*,15) 
15	format('Use mass-radius relation(1) or input values(2)?  ',$)
	read*,answer

	if(answer.eq.1) then

c	use r2=(m2/msolar)**13/15 to get R2 in physical units of
c	solar radii

	  r2temp=m2**(13./15.)

c	get orbital separation in solar radii units using r2temp

	  rsys=r2temp/temp

	  print*,'rsys= ',rsys

c	get the orbital period using Keplers third law

	  tsys=9988.86*sqrt(rsys**3/(m1+m2))
	  print*,'The orbital period in seconds is ',tsys

c       get vsys from rsys

	  vsys=4.37798e5*sqrt((m1+m2)/rsys)


	else if (answer.eq.2) then

13	print*,'Specify either the orbital separation in solar radii(1)'
	print*,'or the orbital period in seconds(2)'
	read*,choice
	
	if(choice.eq.1) then
         print*,'Enter orbital separation in solar radii(6.96e8 meters)'
	 read*,rsys

c	in real units tsys=2pi*sqrt(rsys**3/(G(m1+m2)))

	 tsys=9988.86*sqrt(rsys**3/(m1+m2))
	 print*,'The orbital period in seconds is',tsys
 
c	in real units vsys=sqrt(G*Mass/rsys)

	 vsys=4.37798e5*sqrt((m1+m2)/rsys)

	else if(choice.eq.2) then
	 print*,'Enter orbital period in seconds'
         read*,tsys

c	in real units rsys=(tsys**2*G*(m1+m2)/(4pi**2))**0.3333

	 rsys=2.156036e-3*((m1+m2)*tsys*tsys)**0.333333
	 print*,'This system has an orbital separation (solar radii)=',rsys

c	in real units vsys=sqrt(G*Mass/rsys)

	 vsys=4.37798e5*sqrt((m1+m2)/rsys)

	else

	 go to 13

	end if

	else

	 print*,'You should not be playing with this. Go away.' 
	 go to 5

	end if 

c        write(*,23)
c23      format('Enter inner disk radius lm1 [0.03]: ',$)
c        read(*,*) lm1

        lm1=0.03
	lm1sq=lm1*lm1

	print*,'scaled radius of m1=',lm1,' actual is',lm1*rsys

c 	set the number of timesteps per orbit for the stars

	write( *,14) countmax	
14	format(' Using',i5,' timesteps per orbit')
c14 	format('Sets the number of timesteps per orbit.'/
c     1	'Generally 100-200 is quite sufficient.'/
c     1	'Enter the number of timesteps per orbit:   '/
c     1	'You get',i5)
	ntspo=countmax

c	now we use q to set h. Assumes region is 100 boxes across
c	and 45 boxes from m1 to l1

	h=(mu1+rl)/real(boxmax*0.9)
	print*,'h=   ',h
	
	hinv=1./h
	hsq=h*h
	h2=2.*h
	h2inv=1./h2
	h2sq=h2**2
	large=real(boxmax)*h
	largecheck=(large-h2)**2
	largez=real(boxmax*0.4)*h
	largezcheck=(largez-h)**2
	print*,'large and largez=  ',large,largez
	if (debug) print*,'largecheck and largezcheck=',largecheck,largezcheck
	zshift=largez+2.*h2
	convert=real(2000)/h

c	now scale thermal and sound speeds with system speed for hydrogen

c	write(*,30) 
c30	format('Enter temp of m2 for vth in units of 10^4 k:  ',$)
c	read*,tempv
	tempv=1.0
c	print*,'you get ',tempv

	write(*,35)
35	format('Enter injection temp of gas in units of 10^5 k:  ',$)
	read*,tempu

c	in real units vth=sqrt(kT/massH) and system units vth/vsys

	vth=9090.4*sqrt(tempv)/vsys

c	in real units u=kT(10^5)/(massH*(gamma-1)) and system units u/vsys

	gamma=1.01
	gamma1=gamma-1.

	uinj=8.2635e8*tempu/(vsys*vsys*gamma1)

16	write(*,17) size
17	format('Enter max num of particles in disk(',i7,'max): ',$)
	read*,ntp
	if (ntp.gt.size) then
	  print*,'Whoops. Try again'
	  go to 16
	end if

	alpha=1.5
	beta=1.0
        write(*,20)
20	format('Enter viscosity params alpha, beta [0.5, 0.5]: ',$)
	read(*,*) alpha, beta

	tfudge=0.25
	cscon=gamma*gamma1
	csinj=sqrt(cscon*uinj)
	if(beta.eq.0.0) then
         alphatcon=2.0*hinv
	 betatcon=0.0
	else
	  alphatcon=hinv*(1.0+alpha)
	  betatcon=hinv*sqrt(beta)
	end if
	umin=1e-8*uinj

c	set ufudge to be 100 degrees K

	ufudge=8.2635e5/(vsys*vsys*gamma1)
	csfudge=sqrt(cscon*ufudge)
	tempfactor=gamma1*vsys*vsys*1.21015e-4
	if (debug) print*,'tempfactor=',tempfactor
	xcone=2.*h2
	yzcone=h2

	print*,'uinj=',uinj,' csinj=',csinj

	call makekernel

	pi=real(2)*asin(real(1))
	pi2=real(2)*pi

	return
	end
