	subroutine step

c  This the heart of the program. Each particle is advanced one timestep
c  per pass using the leapfrog method to solve the differential equations.

	include'comblock'

	integer i,j,k,pcount,nshow,numinj,bincount,binflag,binsum
	real energysum

c	decide how many steps to show,# to inject,initialize counters

	write(*,10)
10	format('Enter number of timesteps between writing frames: ',$)
	read*,nshow
	write(*,20)
20	format('Enter number of particles to inject each deltmax: ',$)
	read*,numinj
	write(*,30)
30	format('Enter z offset for L_1 (a=1.0): ',$)
	read*,L1_z
	write(*,40)
40	format('Compress orbit files? (1=yes): ',$)
	read*,compress

	print*,' '
	print*,'  End of user input -- background this job! '
	print*,' '

	count=0
	pcount=0
	badness1=0
	badness2=0
	enersum=0.0
	numlostsysold=0
	numlostm1old=0
	numlostm2old=0

c       initialize the file for the accretion and energy production
c	rates

        open (68,file='accrate',status='unknown')
        close(68)
        open (69,file='enerate',status='unknown')
        close(69)
        open (70,file='accdetail',status='unknown')
        close(70)

c	this is the main loop

	do while (numorb.lt.numorbmax)

	   count=count+1

c	inject new particles if necessary

	   if (cntp.lt.ntp) call injnew(numinj)

	   do i=1,pmax
	      pcount=pcount+1  !increment which pass through the loop this is

c       find smallest occupied time bin

              bincount=0
              binflag=0
              do while(binflag.eq.0) 
                 bincount=bincount+1
                 if (headbin(bincount).gt.0) then
                   smallbin=bincount
                   binflag=1
                 end if
              end do

	      if (smallbin.eq.1) then
	
c	Move all particles by deltmin. Update forces on bin 1.

	         call move1(pcount)
	         highbin=1
	         if(headbin(1).gt.cntp/2) then
	            call sortall
	         else
	            call sort
	         end if
	         call fluid1

	      end if  ! headbin(1).gt.0

	      highbin=high(i)

	      if (smallbin.le.highbin) then

c	Move all particles by delt(smallbin). Update forces on all bins
c	less than or equal to highbin.	

	         call move2(pcount)

c	now save a bit of effort by not checking lists if highbin=nmax
c	or number of particles in bins<= highbin are >cntp/2

	         if(highbin.eq.nmax) then 
	            call sortall
	            call fluid2all
	            call timestep
	            call energyall
	         else
	            binsum=0
	            do j=1,highbin
	               binsum=binsum+headbin(j)
	            end do
	            if(binsum.gt.cntp/2) then
	               call sortall
	            else
	               call sort
	            end if
	            call fluid2
	            call timestep
	            call energy
	         end if

	      end if ! smallbin.le.highbin 

	   end do   ! for the loop through one large time step

c	take care of storing accretion and loss rates for last deltmax

	   lostsys(count)=numlostsys-numlostsysold
	   lostm1(count)=numlostm1-numlostm1old
	   lostm2(count)=numlostm2-numlostm2old
	   numlostsysold=numlostsys
	   numlostm1old=numlostm1
	   numlostm2old=numlostm2

	   if(dotube.eq.1) then
	      do j=1,cntp
	         temperature(j)=u(j)
	         do k=2,headlist(j)
	            temperature(j)=temperature(j)+u(list(k,j))*
     1	            kernel(kerindex(k,j))
	         end do
	         temperature(j)=tempfactor*temperature(j)/rho(j)
	      end do
	      call tube
	   end if

	   pcount=0  !reset loop counter,store energy, time arrays
	   enerarr1(count)=enersum
	   enersum=0.0
	   timearr(count)=real(numorb)+real(count)/real(countmax)
	   energysum=0.0
	   do j=1,cntp
	      energysum=energysum+u(j)
	      dudtarr(j) = u(j) - uold(j)
	      uold(j) = u(j)
	   end do
	   enerarr2(count)=energysum

c	now call writeitframes for phase info

 	   if (mod(count,nshow).eq.0) call writeitframes

c	call show if necessary

c	if (mod(count,nshow).eq.0) call show

c	check if another orbit done. If so, write disk values to files 

	   if (count.eq.countmax) then
	      numorb=numorb+1
	      count=0  
	      call writeit
	   end if

	end do ! end of do while (numorb.lt.numorbmax) loop

c	Done! 

	return
	end
